
// Auswertprogramm
version=20070201;

printf('\n\n\n      W A V 5 G I F - Version %i\n',version);
printf('      G. Heinz GFaI \n\n\n');
printf('      Programm kann in Scilab-Directory stehen \n\n\n');
printf('      Version mit Komparator und 5 Zeitfunktionen \n\n\n');


clear;  //Vorsicht - lscht alle Variablen!



// globale Inits werden aus dem Parameterfile gelesen
      //
      // Im *.par-File sollte stehen z.B.:
      //
      parameter='keine Parameter vorhanden';
      source='keine Quellangabe';
      datum='00.00.0000';
      signum='gh';
      start=90000;			// Startsample
      delta=3000;				// Plotbereich in Samples
      playsound=0;			// Play the WAV-File
      plot_corr=0;			// Punktwolke plotten
      plot_zfkt=1;			// Zeitfunktionen plotten
      plot_f4f5=0;			// Plot auch von f4 und f5?
      f1='UV blue yes yes';		// Plotname Farbe negiert normiert
      f2='IR red yes yes';		// Plotname Farbe negiert normiert
      f3='f2-2*f1 green no';		// Funktion Farbe negiert
      f4='-0.5 -0.6 1.4 -1.4 orange no';	// U+ U- limit+ limit- color negiert
      f5='Ischw pink yes yes'    	// Plotname Farbe negiert normiert


//who_user;     //Anzeige der Variablen; einfacher: Komma hinter den Ausdruck setzen
      datum=date();   //falls im *.par-File nicht vorhanden, wird aktuelles Datum eingesetzt
      
      
// F U N K T I O N E N
        // Offsetbefreiung
        // Die Funktion setzt AC-versetzte Zeitfunktionen wieder auf die Nullinie.
        // Dazu wird angenommen, da die Zeitfunktion innerhalb eines greren, 
        // sortierten Bereiches delta konstant mit Abweichung epsilon ist.
        
        function [out]=nullo(in)  // length(in) muss viel grer als deltat sein.
                    deltat=98;
                    i=1;
                    n=length(in);
                        if n <= 3*deltat then printf('Warning: length(in)=%i < 3*deltat=%i in function nullo');
                        end;
                    eps=99;

                    ort=0;
                    insort=sort(in);          // Zeitfunktion sortieren
                    // clf;plot(insort);plot(in);
                      for i=1:(n-deltat) do;
                        delta=insort(i)-insort(i+deltat);
                          if delta < eps then;  // suche nach Ort des minimalen Abstiegs
                          eps=delta; ort=i;
                          end;
                        nullpunkt=insort(ort);     // hier ist unser gesuchter Nullpunkt
                      end;
                    [out] = (in)-nullpunkt;   // verschieben der Zeitfunktion
                     printf('ort=%i nullpunkt=%i n=%i \n\n',ort,nullpunkt,n); 
                    // plot(out);
        endfunction;
        
        
        // Funktionswerte boolesch negieren
        function [out]=neg(in);
            in=-in;
            [out]=(in)+1;
        endfunction;


        // Normieren auf 0:1 incl. Negation
        function [out]=normi(in)
                    [in]=nullo(in);   // Null offset
                    maxw = max(in);   // Min oder Max suchen?
                    minw = min(in);
                    printf('maxw=%i, minw=%i \n', maxw, minw);
                      if maxw > -minw then
                          maxw=1/maxw;
                          [out] = (in)*maxw;   //
                          else
                          minw=1/minw;
                          [out] = (in)*minw;   //
                      end;
        endfunction;
// Ende Funktionen.



// Parameterfile holen
    filepath=xgetfile('*.par',title='Parameter-File? ');
    exec(filepath);  //ldt File-Inhalt auf die Variablennamen
    //who;     //Anzeige der Variablen
    directory=dirname(filepath);    
    paraname=basename(filepath);
    
    printf('Parameterfile ist hier: \n%s \n\n',filepath);
    printf('PZerlegung: %s\n%s\n',paraname,directory);
    
    tf1=f1;   // Umbelegung der Namen f1...fn, werden spter Vektoren
    tf2=f2;
    tf3=f3;
    tf4=f4;
    tf5=f5;
    printf('Tokens: \n%s\n %s\n %s\n %s\n %s\n\n',tf1,tf2,tf3,tf4,tf5);


// wav-Files einlesen:
   filepath=xgetfile('*.wav',title='Erster WAV-File als F1');
   wavname=basename(filepath);
   [y,Fs,bits]=wavread(filepath); //Fs integer; bits integer;
   printf('\nErste Zeitfunktion: Sample rate %i Hz, ',Fs);
   printf(' %i Bit/Sample \n',bits);
   // eindim. Vektor erzeugen, falls Stereo:
   zeitfkt1=y(:,1); //erste Spalte, Stereo auf Mono plotten, falls.
   lenge=length(y);
   lenge1=length(zeitfkt1);
   printf('Gesamtlnge \t= %i Samples \n\n',lenge1);

   filepath=xgetfile('*.wav',title='Zweiter WAV-File als F2');
   [y,Fs,bits]=wavread(filepath); //Fs integer; bits integer;
   printf('Zweite Zeitfunktion: Sample rate %i Hz, ',Fs);
   printf(' %i Bit/Sample \n',bits);
   // eindim. Vektor erzeugen, falls Stereo:
   zeitfkt2=y(:,1); //erste Spalte, Stereo auf Mono plotten, falls.
   lenge=length(y);
   lenge2=length(zeitfkt2);
   printf('Gesamtlnge \t= %i Samples \n\n',lenge2);

   filepath=xgetfile('*.wav',title='Korrespondierender WAV-file als F5');
   [y,Fs,bits]=wavread(filepath); //Fs integer; bits integer;
   printf('Fnfte Zeitfunktion: Sample rate %i Hz, ',Fs);
   printf(' %i Bit/Sample \n',bits);
   // eindim. Vektor erzeugen, falls Stereo:
   zeitfkt5=y(:,1); //erste Spalte, Stereo auf Mono plotten, falls.
   lenge=length(y);
   lenge5=length(zeitfkt5);
   printf('Gesamtlnge \t= %i Samples \n\n',lenge5);

   printf('%s, %s, %s, \n%s %s %s \n', parameter, source, signum, tf1, tf2, tf3);
   printf('%i, %i \n\n', start, delta);

   
// Plottbereich-Dialogfenster ffnen
   start=evstr(x_dialog('Start at Sample?','start'));
   delta=evstr(x_dialog('Duration (Samples)?','delta'));
   // Ausschnitt:
   stop=start+delta-1;      // sonst sieht Plot nicht gut aus

// Test:
   printf('start= %i \n',start);
   printf('delta= %i \n',delta);
   printf('stop= %i \n\n\n',stop);
   //  who_user();  //Benutzte Parameter anzeigen

//  wav-File abspielen:   

    if playsound==1;
        playsnd(zeitfkt1);        // abspielen
        printf('Spiele Zeitfunktion 1 \n\n');
    end;
    
        
// Auflsung der Strings aus dem Parameterfile:
    
    kdf1=tokenpos(tf1);
    f1_1=part(tf1,kdf1(1,1):kdf1(1,2));  // Plotlegende
    f1_2=part(tf1,kdf1(2,1):kdf1(2,2));  // Plotfarbe
    f1_3=part(tf1,kdf1(3,1):kdf1(3,2));  // negiert
    f1_4=part(tf1,kdf1(4,1):kdf1(4,2));  // normiert
    ft1_1='f1='+f1_1;
    
    kdf2=tokenpos(tf2);
    f2_1=part(tf2,kdf2(1,1):kdf2(1,2));
    f2_2=part(tf2,kdf2(2,1):kdf2(2,2));
    f2_3=part(tf2,kdf2(3,1):kdf2(3,2));
    f2_4=part(tf1,kdf1(4,1):kdf1(4,2));  // normiert
    ft2_1='f2='+f2_1;
    
    kdf3=tokenpos(tf3);
    f3_1=part(tf3,kdf3(1,1):kdf3(1,2));
    f3_2=part(tf3,kdf3(2,1):kdf3(2,2));
    f3_3=part(tf3,kdf3(3,1):kdf3(3,2));
    ft3_1='f3='+f3_1;   // not used

    kdf4=tokenpos(tf4);
    f4_1=part(tf4,kdf4(1,1):kdf4(1,2));
    f4_2=part(tf4,kdf4(2,1):kdf4(2,2));
    f4_3=part(tf4,kdf4(3,1):kdf4(3,2));
    f4_4=part(tf4,kdf4(4,1):kdf4(4,2));
    f4_5=part(tf4,kdf4(5,1):kdf4(5,2));
    f4_6=part(tf4,kdf4(6,1):kdf4(6,2));
    ft4_1='f4='+f4_1;   // not used

    kdf5=tokenpos(tf5);
    f5_1=part(tf5,kdf5(1,1):kdf5(1,2));  // Plotlegende
    f5_2=part(tf5,kdf5(2,1):kdf5(2,2));  // Plotfarbe
    f5_3=part(tf5,kdf5(3,1):kdf5(3,2));  // negiert
    f5_4=part(tf1,kdf1(4,1):kdf1(4,2));  // normiert
    ft5_1='f5='+f5_1;
       
       

// Punktwolke plotten?

if plot_corr==1 then;    
    
      // Waitbar Window:
         winId=waitbar('working...');
         realtimeinit(lenge2/Fs);
         for j=0:0.1:1;
          realtime(j);
          waitbar(j,winId);
         end;
         winclose(winId);

      // Lissajous-Plot:
         clf(0);    // clear window #0
         scf(0);    // set the current graphic window to #0
         lang=string(lenge2);
         samp=lang+' Samples, '+string(Fs)+' Hz ';

         // Vorbereitung Plot-Titelzeilen 1 und 2
         titel1='Korrelationsplot fr '+parameter+' vom '+datum;
         titel2='Source '+source+' '+signum+' '+samp;

         plot2d([-zeitfkt1],[-zeitfkt2],0);
         xtitle([titel1 titel2],f1_1,f2_1);
      //   halt;

      // Plot to GIF-file
         filename=directory+'\'+paraname+'_'+source+'_'+f1_1+'_'+f2_1+'_corr'+'.gif';
         xs2gif(0,filename);
         printf('Korrellogramm *.GIF gespeichert unter \n%s \n\n', filename);

end;    //end if Punktwolke plotten


// Zeitfkt. ausschneiden
    
            f1=zeitfkt1(start:stop);
            if f1_3=='yes';                // wenn invers,
              [f1] = 0-(f1);               // dann negieren
            end;


            f2=zeitfkt2(start:stop);
            if f2_3=='yes';                // wenn invers,
              [f2] = 0-(f2);               // dann negieren
            end;


            f5=zeitfkt5(start:stop);
            if f5_3=='yes';                // wenn invers,
              [f5] = 0-(f5);               // dann negieren
            end;

            // clf(3); scf(3);
            // printf('Lissajousplot norm1 gegen norm2 \n')
            // plot2d(f1,f2,1);   //Plotauszug
            // halt;

//Plot der Zeitfunktionen

if plot_zfkt==1 then;      // Zeitfunktionen plotten?

        // Kanle vorbereiten: 
        
          // f1
              if f1_3=='yes' then f1=neg(f1); end;
              if f1_4=='yes' then f1=normi(f1); end;
              
          // f2
              if f2_3=='yes' then f2=neg(f2); end;
              if f2_4=='yes' then f2=normi(f2); end;
          
          // f3
              f3=evstr(f3_1);   // math. Ausdruck ausfhren
              if f3_3=='yes' then f3=-f3; end;
              
          // f4 Schwellwertfunktion basteln:
              uplus=evstr(f4_1);      // Terme aus String extrahieren
              uminus=evstr(f4_2); 
              limitplus=evstr(f4_3); 
              limitminus=evstr(f4_4); 
              n=length(f3);
              hyst=1;
              
              f4=f3;          // init f4
              
              for i=1:n;      //fr alle Samples i=1 bis n
                  if f4(i) > uplus then hyst=1;
                  end;
                  
                  if f4(i) < uminus then hyst=-1;
                  end;
                  
                  if hyst==1 then f4(i)=limitplus;
                  end;
                  
                  if hyst==-1 then f4(i)=limitminus;
                  end;
              end; //end for
         
              ft4_1='f4=f3('+f4_1+';'+f4_2+';'+f4_3+';'+f4_4+')';
              
              if f4_6=='yes' then f4=-(f4);     // f4 negiert
              end;

          // f5
              if f5_3=='yes' then f5=neg(f5); end;
              if f5_4=='yes' then f5=normi(f5); end;

        
        
// Zeitfunktionen plotten
        
        titel1='Normierte Zeitfkt. der Emissionen fr '+parameter+' vom '+datum;
        titel2='Source '+' '+source+' '+signum+' ab Sample '+string(start)+', '+string(Fs)+' Hz ';
        
if plot_f4f5==1 then;        
    // Plot:
        clf(1);   // Plotwindow lschen
        scf(1);   // set the current graphic window to #1
        plot2d([],[f1,f2,f3,f4,f5],style=[color(f1_2),color(f2_2),color(f3_2),color(f4_5),color(f5_2)]);
        legends([ft1_1,ft2_1,ft3_1,ft4_1,ft5_1],[[color(f1_2);1],[color(f2_2);1],[color(f3_2);1],[color(f4_5);1],[color(f5_2);1]],with_box=%f,opt="lr");
        xtitle([titel1 titel2],'n','y');
else;
    // Plot:
        clf(1);
        scf(1);  // set the current graphic window to #1
        plot2d([],[f1,f2,f3],style=[color(f1_2),color(f2_2),color(f3_2)]);
        legends([ft1_1,ft2_1,ft3_1],[[color(f1_2);1],[color(f2_2);1],[color(f3_2);1]],with_box=%f,opt="lr");
        xtitle([titel1 titel2],'n','y');

end;    //if Zeitfunktionen

    // Plot to GIF-file
        // filename=source+'_'+f1_1+'_'+f2_1+'_zfkt'+'.gif';
        delts=string(delta);
        filename=directory+'\'+paraname+'_'+source+'_'+f1_1+'_'+f2_1+'_zfkt'+'_'+delts+'.gif';
        xs2gif(1,filename);

// Fertig.    
    printf('\nfertig. \n\n');
    printf('Zeitfkt. *.GIF gespeichert unter \n%s \n\n', filename);
        
end;    //end 
